import java.awt.*;//for class Point

public class AccessibilityMatrix
{
	static int iCells[][];

	public static void init()
	{
		iCells = new int[8][8];

		iCells[0][0] = 2;
		iCells[0][1] = 3;
		iCells[0][2] = 4;
		iCells[0][3] = 4;
		iCells[0][4] = 4;
		iCells[0][5] = 4;
		iCells[0][6] = 3;
		iCells[0][7] = 2;

		iCells[1][0] = 3;
		iCells[1][1] = 4;
		iCells[1][2] = 6;
		iCells[1][3] = 6;
		iCells[1][4] = 6;
		iCells[1][5] = 6;
		iCells[1][6] = 4;
		iCells[1][7] = 3;

		iCells[2][0] = 4;
		iCells[2][1] = 6;
		iCells[2][2] = 8;
		iCells[2][3] = 8;
		iCells[2][4] = 8;
		iCells[2][5] = 8;
		iCells[2][6] = 6;
		iCells[2][7] = 4;

		iCells[3][0] = 4;
		iCells[3][1] = 6;
		iCells[3][2] = 8;
		iCells[3][3] = 8;
		iCells[3][4] = 8;
		iCells[3][5] = 8;
		iCells[3][6] = 6;
		iCells[3][7] = 4;

		iCells[4][0] = 4;
		iCells[4][1] = 6;
		iCells[4][2] = 8;
		iCells[4][3] = 8;
		iCells[4][4] = 8;
		iCells[4][5] = 8;
		iCells[4][6] = 6;
		iCells[4][7] = 4;

		iCells[5][0] = 4;
		iCells[5][1] = 6;
		iCells[5][2] = 8;
		iCells[5][3] = 8;
		iCells[5][4] = 8;
		iCells[5][5] = 8;
		iCells[5][6] = 6;
		iCells[5][7] = 4;

		iCells[6][0] = 3;
		iCells[6][1] = 4;
		iCells[6][2] = 6;
		iCells[6][3] = 6;
		iCells[6][4] = 6;
		iCells[6][5] = 6;
		iCells[6][6] = 4;
		iCells[6][7] = 3;

		iCells[7][0] = 2;
		iCells[7][1] = 3;
		iCells[7][2] = 4;
		iCells[7][3] = 4;
		iCells[7][4] = 4;
		iCells[7][5] = 4;
		iCells[7][6] = 3;
		iCells[7][7] = 2;
	}

	public static int getAccessibility( Point ptPos )
	{
		return iCells[ptPos.x][ptPos.y];
	}

	public static int getAptMove( int[] iMoves, Point ptPos )
	{
		int iAptMove;
		int i;
		int iCurrentAccessibility;
		Point ptTemp = new Point( ptPos );

		iAptMove = iMoves[0];
		ptTemp.x += KnightMoves.iHorizontalMove[ iMoves[0] ];
		ptTemp.y += KnightMoves.iVerticalMove[ iMoves[0] ];
		iCurrentAccessibility = getAccessibility( ptTemp );

		for( i = 1 ; ( i < 8 ) && ( iMoves[i] != -1 ) ; ++i )
		{
			ptTemp = new Point( ptPos );
			ptTemp.x += KnightMoves.iHorizontalMove[ iMoves[i] ];
			ptTemp.y += KnightMoves.iVerticalMove[ iMoves[i] ];
			int iNewAccessibility = getAccessibility( ptTemp );

			if( iNewAccessibility < iCurrentAccessibility )
			{
				iCurrentAccessibility = iNewAccessibility;
				iAptMove = iMoves[i];
			}
			else if( iNewAccessibility == iCurrentAccessibility )
			{
				int iNewAcc = getLeastAccessibility( ptTemp );
				
				ptTemp = new Point( ptPos );
				ptTemp.x += KnightMoves.iHorizontalMove[ iAptMove ];
				ptTemp.y += KnightMoves.iVerticalMove[ iAptMove ];
				
				int iOldAcc = getLeastAccessibility( ptTemp );
				
				if( iNewAcc < iOldAcc )
				{
					iCurrentAccessibility = iNewAccessibility;
					iAptMove = iMoves[i];
				}
			}
		}

		return iAptMove;
	}
	
	private static int getLeastAccessibility( Point ptPos )
	{
		int iAccessibilities[] = getAccessibilities( ptPos );
		int iLeastAccessibility;
		int iCurrentAccessibility, i;
		
		iLeastAccessibility = iAccessibilities[0];
		
		for( i = 1 ; (i < iAccessibilities.length) ; ++i )
		{
			iCurrentAccessibility = iAccessibilities[i];
			
			if( iCurrentAccessibility < iLeastAccessibility )
				iLeastAccessibility = iCurrentAccessibility;
		}
		
		return iLeastAccessibility;
	}
	
	private static int[] getAccessibilities( Point ptPos )
	{
		int iMoves[] = KnightMoves.enumerateMoves( ptPos );
		int iAccessibilities[] = new int[8];
		
		for( int i = 0 ; (i < iAccessibilities.length) && 
						(iMoves[i] != -1) ; ++i )
		{
			Point ptTemp = new Point( ptPos );
			ptTemp.x += KnightMoves.iHorizontalMove[ iMoves[i] ];
			ptTemp.y += KnightMoves.iVerticalMove[ iMoves[i] ];
			
			iAccessibilities[i] = getAccessibility( ptTemp );
		}
		
		return iAccessibilities;
	}
}